LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY COUNTCONT2 IS

	PORT
	(
		X_DATA		: IN 	STD_LOGIC_VECTOR(7 downto 0);
		Y_DATA		: IN 	STD_LOGIC_VECTOR(7 downto 0);
		B_RESET		: IN	STD_LOGIC;
		CLK			: IN	STD_LOGIC;
		B_IORN		: IN	STD_LOGIC;
		RE_X		: IN	STD_LOGIC;
		RE_Y		: IN	STD_LOGIC;
		OUT_DATA	: OUT 	STD_LOGIC_VECTOR(7 downto 0)
	);
END COUNTCONT2;

ARCHITECTURE RTL OF COUNTCONT2 IS
		SIGNAL	LATCH_X	: STD_LOGIC_VECTOR(7 downto 0);
		SIGNAL	LATCH_Y	: STD_LOGIC_VECTOR(7 downto 0);
		SIGNAL	READ_X	: STD_LOGIC;
		SIGNAL	READ_Y	: STD_LOGIC;

BEGIN
READ_X <= RE_X and not B_IORN;
READ_Y <= RE_Y and not B_IORN;	
process(B_IORN,B_RESET,CLK)
begin
	if (B_RESET='1') then
		LATCH_X <= "00000000";
		LATCH_Y <= "00000000";
	elsif (CLK'event and CLK='1') then
		if (B_IORN = '1') then
			LATCH_X <= X_DATA;
			LATCH_Y <= Y_DATA;
		end if;
	end if;
end process;
process(READ_X,READ_Y,B_RESET)
	begin
		if (READ_X='1') then
			OUT_DATA <= LATCH_X;
		elsif (READ_Y='1') then
			OUT_DATA <= LATCH_Y;
		else
			OUT_DATA <= "ZZZZZZZZ";
		end if;
end process;
END RTL;




